=== modified file 'fai.py'
--- fai.py	2005-10-24 06:21:01 +0000
+++ fai.py	2005-10-24 07:01:08 +0000
@@ -30,20 +30,23 @@
     :return: The direct merges
     :rtype: list of `pybaz.Patchlog`
     """
-    indirect = []
-    direct = []
+    indirect = set()
     logs = list(merges)
     if not logs:
         return []
     for log in logs:
         try:
-            this_indirect = [f for f in log.new_patches if f != log.revision]
+            this_indirect = set([str(f) for f in log.new_patches 
+                                 if f != log.revision and 
+                                     str(f) not in indirect])
         except pybaz.errors.NamespaceError:
             print
             print "log ", log, " unusable, attempting to use archive copy."
             log = pybaz.Revision(str(log.revision)).patchlog
-            this_indirect = [f for f in log.new_patches if f != log.revision]
-        indirect.extend(this_indirect)
+            this_indirect = set([str(f) for f in log.new_patches 
+                                 if f != log.revision and 
+                                     str(f) not in indirect])
+        indirect.update(this_indirect)
         if log.continuation_of is not None:
             # continuations list everything in new_patches
             continue
@@ -68,9 +71,10 @@
                         found = True
                 print "ancestor of %s is %s" % (log.revision, ancestor)
         if ancestor is not None:
-            indirect.append(ancestor)
-    return [log.revision for log in logs if not log.revision in indirect and 
-            log.revision not in excludes]
+            indirect.add(str(ancestor))
+    return [log.revision for log in logs if not str(log.revision) in indirect
+            and log.revision not in excludes]
+
 
 def namespace_previous(revision):
     if revision.patchlevel == 'base-0':

